(in-package :remote-snake-server-api)



(defclass api ()
  ((gm
    :initform (make-instance 'game-manager))))

  
;;; TODO: Handle errors (valid json etc..)
(defun parse-request (request)
  (flet ((normalizer (key)
                     (string-upcase key)))
  (let ((p-request (parse request :normalize-all t :keyword-normalizer #'normalizer )))
    p-request)))

(defmethod handle-new-game ((api api) data)
  (with-slots (gm) api
    (let* ((game-id (create-game gm)))
      (let ((game-dump (dump gm game-id)))
        (setf (getf game-dump :game-over) :null) ; Define nil as null (for json)
      (to-json
       (append (list :type "state") game-dump))))))

;;; TODO: RETURN JSON !!!!
(defmethod handle-update ((api api) data)
  (with-slots (gm) api
    (let* ((dir (getf data :direction))
          (game-id (getf data :game-id))
          (game (get-game gm game-id)))
      (cond
       ((equal dir "up") (setf dir :up))
       ((equal dir "down") (setf dir :down))
       ((equal dir "left") (setf dir :left))
       ((equal dir "right") (setf dir :right))
       (t (setf dir nil)))
      (if dir
          (refresh game :dir dir)
        (refresh game))
      (append (list :type "update") (dump gm game-id)))))

            

(defmethod handle-request ((api api) request)
  (let* ((data (parse-request request))
         (type (getf data :type)))
    (cond
     ((equal type "new-game") (handle-new-game api data))
     ((equal type "update") (handle-update api data))
     (t (format t "Unknow type")))))



